﻿-- Author   Kurapica
-- Date     2008/12/11
do
    -- Check Version
	local version = 1
	if not IGAS.Register("Cube.BugList", version) then
		return
	end
		
    local L = IGAS.Localization.GetLocal("Cube")
    local CreateFrame = IGAS.GUI.CreateFrame    
    
    local ErrList = {}
    local maxErr = 99
    local errIndex = 0
    local width
    local _G = getfenv(0)

    BINDING_NAME_CUBE_BUGLIST = L["Simple Bug List"]

    local bugF = CreateFrame("Form", "Cube_BugList")
    bugF.Height = 400
    bugF.Width = 500
    bugF.Caption = "Cube - "..L["Simple Bug List"]
    bugF.Visible = false
    
    local btnRight = CreateFrame("Button", "RightBtn", bugF)
    btnRight.FrameLevel = bugF.FrameLevel + 2
    btnRight:SetWidth(32)
    btnRight:SetHeight(32)
    btnRight:ClearAllPoints()
    btnRight:SetPoint("TOPRIGHT", bugF, "TOPRIGHT", -26, -4)
    btnRight:SetNormalTexture("Interface\\BUTTONS\\UI-SpellbookIcon-NextPage-Up")
    btnRight:SetPushedTexture("Interface\\BUTTONS\\UI-SpellbookIcon-NextPage-Down")
    btnRight:SetDisabledTexture("Interface\\BUTTONS\\UI-SpellbookIcon-NextPage-Disabled")
    btnRight:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight", "ADD")
    btnRight:Disable()
    local rightNum = CreateFrame("FontString", "RightNum", btnRight, "ARTWORK", "GameFontHighlight")
    rightNum:SetAllPoints(btnRight)
    
    local btnLeft = CreateFrame("Button", "LeftBtn", bugF)
    btnLeft.FrameLevel = bugF.FrameLevel + 2
    btnLeft:SetWidth(32)
    btnLeft:SetHeight(32)
    btnLeft:ClearAllPoints()
    btnLeft:SetPoint("RIGHT", btnRight, "LEFT", 0, 0)
    btnLeft:SetNormalTexture("Interface\\BUTTONS\\UI-SpellbookIcon-PrevPage-Up")
    btnLeft:SetPushedTexture("Interface\\BUTTONS\\UI-SpellbookIcon-PrevPage-Down")
    btnLeft:SetDisabledTexture("Interface\\BUTTONS\\UI-SpellbookIcon-PrevPage-Disabled")
    btnLeft:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight", "ADD")
    btnLeft:Disable()    
    local leftNum = CreateFrame("FontString", "LeftNum", btnLeft, "ARTWORK", "GameFontHighlight")
    leftNum:SetAllPoints(btnLeft)

    -- Text View
    local textView = CreateFrame("MultiLineTextBox", "Text", bugF)
    textView:SetPoint("TOPLEFT", bugF, "TOPLEFT", 6, -34)
    textView:SetPoint("BOTTOMRIGHT", bugF, "BOTTOMRIGHT", -6, 50)
    
    -- Debug Button
    local debug = CreateFrame("Button", "Debug", bugF)
    debug.Height = 24
    debug.Width = 60
    debug.Style = "NORMAL"
    debug.Text = L["Debug"]
    width = debug:GetTextWidth()
    if ( width > 50 ) then
        debug:SetWidth(width + 20)
    else
        debug:SetWidth(60)
    end
    debug:SetPoint("BOTTOMRIGHT", bugF, "BOTTOMRIGHT", -4, 20)
    
    -- Code Button
    local code = CreateFrame("Button", "Code", bugF)
    code.Height = 24
    code.Width = 60
    code.Style = "NORMAL"
    code.Text = L["Code"]
    width = code:GetTextWidth()
    if ( width > 50 ) then
        code:SetWidth(width + 20)
    else
        code:SetWidth(60)
    end
    code:SetPoint("RIGHT", debug, "LEFT", -6, 0)
    
    -- Clear Button
    local clear = CreateFrame("Button", "Clear", bugF)
    clear.Height = 24
    clear.Width = 60
    clear.Style = "NORMAL"
    clear.Text = L["Clear"]
    width = clear:GetTextWidth()
    if ( width > 50 ) then
        clear:SetWidth(width + 20)
    else
        clear:SetWidth(60)
    end
    clear:SetPoint("BOTTOMLEFT", bugF, "BOTTOMLEFT", 4, 20)
    
    -- ClearAll Button
    local clearAll = CreateFrame("Button", "ClearAll", bugF)
    clearAll.Height = 24
    clearAll.Width = 60
    clearAll.Style = "NORMAL"
    clearAll.Text = L["Clear All"]
    width = clearAll:GetTextWidth()
    if ( width > 50 ) then
        clearAll:SetWidth(width + 20)
    else
        clearAll:SetWidth(60)
    end
    clearAll:SetPoint("LEFT", clear, "RIGHT", 6, 0)
    
    -- Enable Button
    local enable = CreateFrame("Button", "EnableButton", bugF)
    enable.Height = 24
    enable.Width = 60
    enable.Style = "NORMAL"
    enable.Text = L["Enabled"]
    width = enable:GetTextWidth()
    if ( width > 50 ) then
        enable:SetWidth(width + 20)
    else
        enable:SetWidth(60)
    end
    enable:SetPoint("LEFT", clearAll, "RIGHT", 6, 0)
    
    -- Minimap Icon
    local icon = CreateFrame("MinimapIcon", "MapIcon", bugF)
    icon:SetIcon("Interface\\Icons\\INV_Misc_QuestionMark")
    icon.Tooltip = L["Simple Bug List"]
    icon.Visible = false
    
    -- BugNum
    local bugNum = CreateFrame("FontString", "BugNum", icon, "ARTWORK", "GameFontHighlight")
    bugNum:SetAllPoints(icon)
    
    -- Scripts
    local function Refresh()        
        if errIndex < 1 then
            errIndex = 1
        end
        if errIndex > table.getn(ErrList) then
            errIndex = table.getn(ErrList)
        end
        if errIndex < 2 then
            btnLeft:Disable()
            leftNum.Text = ""
        else
            btnLeft:Enable()
            leftNum.Text = tostring(errIndex - 1)
        end
        
        if errIndex > table.getn(ErrList) - 1 then
            btnRight:Disable()
            rightNum.Text = ""
        else
            btnRight:Enable()
            rightNum.Text = tostring(table.getn(ErrList) - errIndex)
        end
        
        textView.Text = ErrList[errIndex] or ""
        if table.getn(ErrList) > 0 then
            bugNum.Text = tostring(table.getn(ErrList))
            if not icon.Visible then
                PlaySound("igMainMenuOpen")
                icon.Visible = true
            end
        else
            bugNum.Text = ""
            icon.Visible = false
        end
    end
    
    function btnLeft:OnClick()
        errIndex = errIndex - 1
        if errIndex < 1 then
            errIndex = 1
        end
        if errIndex > table.getn(ErrList) then
            errIndex = table.getn(ErrList)
        end
        Refresh()
    end
    
    function btnLeft:OnEnter()
        leftNum.Visible = false
    end
    
    function btnLeft:OnLeave()
        leftNum.Visible = true
    end
    
    function btnRight:OnClick()
        errIndex = errIndex + 1
        if errIndex < 1 then
            errIndex = 1
        end
        if errIndex > table.getn(ErrList) then
            errIndex = table.getn(ErrList)
        end
        Refresh()
    end
    
    function btnRight:OnEnter()
        rightNum.Visible = false
    end
    
    function btnRight:OnLeave()
        rightNum.Visible = true
    end
    
    function clear:OnClick()
        if ErrList[errIndex] then
            table.remove(ErrList, errIndex)
            if errIndex > table.getn(ErrList) then
                errIndex = table.getn(ErrList)
            end
            Refresh()
        end
    end
    
    function clearAll:OnClick()
        if table.getn(ErrList) > 0 then
            for i = table.getn(ErrList), 1, -1 do
                table.remove(ErrList, i)
            end
        end
        errIndex = 0
        Refresh()
    end
    
    function code:OnClick()
        if bugF.Parent:GetChild("Cube_Main") then
            bugF.Parent:GetChild("Cube_Main").Visible = true
        end
    end
    
    function debug:OnClick()
        if bugF.Parent:GetChild("Cube_Debug") then
            bugF.Parent:GetChild("Cube_Debug").Visible = true
        end
    end
    
    function enable:OnClick()
        if CubeSave.DisableBugList then
            bugF:Fire("OnEnable")
        else
            bugF:Fire("OnDisable")
        end
    end
    
    function bugF:OnEnable()
        enable.Text = L["Enabled"]
        width = enable:GetTextWidth()
        if ( width > 50 ) then
            enable:SetWidth(width + 20)
        else
            enable:SetWidth(60)
        end
        CubeSave.DisableBugList = nil
    end
    
    function bugF:OnDisable()
        enable.Text = L["Disabled"]
        width = enable:GetTextWidth()
        if ( width > 50 ) then
            enable:SetWidth(width + 20)
        else
            enable:SetWidth(60)
        end
        CubeSave.DisableBugList = true
    end
    
    function bugF:OnShow()
        Refresh()
    end
    
    function icon:OnPositionChanged()
        if self.Init then
            CubeSave.IconPosition = icon.Position
        end
    end
    
    function icon:OnClick()
        bugF.Visible = not bugF.Visible
    end
    
    -- Core Function
    local real_seterrorhandler = seterrorhandler
    
    -- Error handler
    local function grabError(err)
        if CubeSave.DisableBugList then return end
        if table.getn(ErrList) >= maxErr then return end
    
        if not err or err == "" then
            return
        end
        
        -- Get the full backtrace
        local real =
            err:find("^.-([^\\]+\\)([^\\]-)(:%d+):(.*)$") or
            err:find("^%[string \".-([^\\]+\\)([^\\]-)\"%](:%d+):(.*)$") or
            err:find("^%[string (\".-\")%](:%d+):(.*)$") or err:find("^%[C%]:(.*)$")
    
        err = err .. "\n" .. debugstack(real and 4 or 3)
        local errorType = "error"
    
        -- Normalize the full paths into last directory component and filename.
        local errmsg = ""
        
        for trace in err:gmatch("(.-)\n") do
            local match, found, path, file, line, msg, _
            found = false
        
            -- "Interface\AddOns\path\to\file.lua:linenum:message"
            if not found then
                match, _, path, file, line, msg = trace:find("^.-[A%.][d%.][d%.][Oo]ns\\(.*)([^\\]-)(:%d+):(.*)$")
                if match then
                    found = true
                    local addon = path:gsub("\\.*$", "")
                    local addonObject = _G[addon]
                    if not addonObject then
                        addonObject = _G[addon:match("^[^_]+_(.*)$")]
                    end
                    local version, revision = nil, nil
                    local objectName = addon:upper()
                    if not version then version = _G[objectName .. "_VERSION"] end
                    if not revision then revision = _G[objectName .. "_REVISION"] or _G[objectName .. "_REV"] end
                    if not version then version = GetAddOnMetadata(addon, "Version") end
                    if not version and revision then version = revision
                    elseif type(version) == "string" and revision and not version:find(revision) then
                        version = version .. "." .. revision
                    end
                    if version then
                        path = addon .. "-" .. version .. path:gsub("^[^\\]*", "")
                    end
                end
            end
            
            -- "path\to\file.lua:linenum:message"
            if not found then
                match, _, path, file, line, msg = trace:find("^.-([^\\]+\\)([^\\])(:%d+):(.*)$")
                if match then
                    found = true
                end
            end
    
            -- "[string \"path\\to\\file.lua:<foo>\":linenum:message"
            if not found then
                match, _, path, file, line, msg = trace:find("^%[string \".-([^\\]+\\)([^\\]-)\"%](:%d+):(.*)$")
                if match then
                    found = true
                end
            end
    
            -- "[string \"FOO\":linenum:message"
            if not found then
                match, _, file, line, msg = trace:find("^%[string (\".-\")%](:%d+):(.*)$")
                if match then
                    found = true
                    path = "<string>:"
                end
            end
    
            -- "[C]:message"
            if not found then
                match, _, msg = trace:find("^%[C%]:(.*)$")
                if match then
                    found = true
                    path = "<in C code>"
                    file = ""
                    line = ""
                end
            end
        
            -- Anything else
            if not found then
                path = trace--"<unknown>"
                file = ""
                line = ""
                msg = line
            end
    
            -- Add it to the formatted error
            errmsg = errmsg .. path .. file .. line .. ":" .. msg .. "\n"
        end
        
        table.insert(ErrList, errmsg)
        Refresh()
    end
    
    bugF.grabError = grabError
    
    real_seterrorhandler(grabError)
    function seterrorhandler() end
end