﻿-- Author      : Kurapica
-- Create Date : 6/12/2008 1:10:38 AM

-- Enum
do
	-- Check Version
	local version = 1
	if not IGAS.Register("IGAS.GUI.Base.Enum", version) then
		return
	end

	IGAS.GUI.Base.Enum = {
        -- ScriptType
        ["ScriptType"] = {
            "OnLoad",
            "OnAttributeChanged",
            "OnSizeChanged",
            "OnEvent",
            "OnUpdate",
            "OnShow",
            "OnHide",
            "OnEnter",
            "OnLeave",
            "OnMouseDown",
            "OnMouseUp",
            "OnMouseWheel",
            "OnDragStart",
            "OnDragStop",
            "OnReceiveDrag",
            "PreClick",
            "OnClick",
            "PostClick",
            "OnDoubleClick",
            "OnValueChanged",
            "OnUpdateModel",
            "OnAnimFinished",
            "OnEnterPressed",
            "OnEscapePressed",
            "OnSpacePressed",
            "OnTabPressed",
            "OnTextChanged",
            "OnTextSet",
            "OnCursorChanged",
            "OnInputLanguageChanged",
            "OnEditFocusGained",
            "OnEditFocusLost",
            "OnHorizontalScroll",
            "OnVerticalScroll",
            "OnScrollRangeChanged",
            "OnCharComposition",
            "OnChar",
            "OnKeyDown",
            "OnKeyUp",
            "OnColorSelect",
            "OnHyperlinkEnter",
            "OnHyperlinkLeave",
            "OnHyperlinkClick",
            "OnMessageScrollChanged",
            "OnMovieFinished",
            "OnMovieShowSubtitle",
            "OnMovieHideSubtitle",
            "OnTooltipSetDefaultAnchor",
            "OnTooltipCleared",
            "OnTooltipAddMoney",
            "OnTooltipSetUnit",
            "OnTooltipSetItem",
            "OnTooltipSetSpell",
            "OnTooltipSetQuest",
            "OnTooltipSetAchievement",
        },
		--- OutLine
		["OutLine"] = {
			"NORMAL",
			"THICK",
		}, 
		--- FontObject
		["FontObject"] = {
			"SystemFont",
			"GameFontNormal",
			"GameFontNormalSmall",
			"GameFontNormalLarge",
			"GameFontHighlight",
			"GameFontHighlightSmall",
			"GameFontHighlightSmallOutline",
			"GameFontHighlightLarge",
			"GameFontDisable",
			"GameFontDisableSmall",
			"GameFontDisableLarge",
			"GameFontGreen",
			"GameFontGreenSmall",
			"GameFontGreenLarge",
			"GameFontRed",
			"GameFontRedSmall",
			"GameFontRedLarge",
			"GameFontWhite",
			"GameFontDarkGraySmall",
			"NumberFontNormalYellow",
			"NumberFontNormalSmallGray",
			"QuestFontNormalSmall",
			"DialogButtonHighlightText",
			"ErrorFont",
			"TextStatusBarText",
			"CombatLogFont", 
		}, 
		--- FrameStrata
		["FrameStrata"] = {
			"PARENT",
			"BACKGROUND",
			"LOW",
			"MEDIUM",
			"HIGH",
			"DIALOG",
			"FULLSCREEN",
			"FULLSCREEN_DIALOG",
			"TOOLTIP", 
		}, 
		--- JustifyH
		["JustifyH"] = {
			"LEFT",
			"RIGHT",
			"CENTER",
		},
		--- JustifyV
		["JustifyV"] = {
			"TOP",
			"BOTTOM",
			"MIDDLE",
		},
		--- Point
		["Point"] = {
			"CENTER",
			"TOP",
			"BOTTOM",
			"LEFT",
			"RIGHT", 
			"TOPLEFT",
			"TOPRIGHT",
			"BOTTOMLEFT",
			"BOTTOMRIGHT",
		},
		--- Layer
		["Layer"] = {
			"BACKGROUND", 			-- Level 0. Place the background of your frame here.
			"BORDER",		 		-- Level 1. Place the artwork of your frame here .
			"ARTWORK", 				-- Level 2. Place the artwork of your frame here.
			"OVERLAY", 				-- Level 3. Place your text, objects, and buttons in this level.
			"HIGHLIGHT", 			-- Level 4. Place your text, objects, and buttons in this level. 
		}, 
		--- AlphaMode
		["AlphaMode"] = {
			"DISABLE",				-- opaque texture
			"BLEND",				-- normal painting on top of the background, obeying alpha channels if present in the image (uses alpha)
			"ALPHAKEY",				-- one-bit alpha
			"ADD",					-- additive blend
			"MOD",					-- modulating blend 
		},
        --- ButtonState
        ["ButtonState"] = {
            "PUSHED",
            "NORMAL",
        },
        --- InsertMode
        ["InsertMode"] = {
        	"TOP",
        	"BOTTOM",
        },
        --- Orientation
        ["Orientation"] = {
        	"HORIZONTAL",
        	"VERTICAL",
        },
		-- Direction
		["Direction"] = {
			"TOP",
			"BOTTOM",
			"LEFT",
			"RIGHT",
		},
	}

end