﻿-- Author      : Kurapica
-- Create Date : 8/03/2008 17:14

--------------------------
-- SingleTextBox        --
--------------------------
do
	-- Check Version
	local version = 1

	if not IGAS.Register("IGAS.GUI.Widget.SingleTextBox", version) then
		return
	end
		
    local getmetatable = getmetatable
    local pairs = pairs
    local ipairs = ipairs
    local type = type
    local error = error
    local CreateFrame = IGAS.GUI.CreateFrame
    
	local _WidgetName = "SingleTextBox"
    local _Base = "EditBox"

	local _GUI = IGAS.GUI
	local _Widget = IGAS.GUI.Widget
    local _BaseFunc = IGAS.GUI.Base.Func
	local _PropertyType = IGAS.GUI.Base.PropertyType
	
	-- ScriptType
	local _ScriptType = {
    }
	
	--	FuncProxy
	local _FuncProxy = {
	}
	
	--	Property
	local _Property = {
	}
	
    -- Scripts
    local _FrameBackdrop = {
        bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        tile = true, tileSize = 16, edgeSize = 16,
        insets = { left = 3, right = 3, top = 3, bottom = 3 }
    }
    
    local function OnEscapePressed(self, ...)
        local wrapper = _BaseFunc.GetWrapper(self)		
		
	    self:ClearFocus()
		
		if (wrapper["OnEscapePressed"] and type(wrapper["OnEscapePressed"]) == "function") then
			wrapper["OnEscapePressed"](wrapper, ...)
		end
    end
    
	local function OnEditFocusLost(self, ...)
        local wrapper = _BaseFunc.GetWrapper(self)		
		
		self:HighlightText(0, 0)
		
		if (wrapper["OnEditFocusLost"] and type(wrapper["OnEditFocusLost"]) == "function") then
			wrapper["OnEditFocusLost"](wrapper, ...)
		end
    end
	
    local function OnEditFocusGained(self, ...)
        local wrapper = _BaseFunc.GetWrapper(self)
        
	    self:HighlightText()	
				
		if (wrapper["OnEditFocusGained"] and type(wrapper["OnEditFocusGained"]) == "function") then
			wrapper["OnEditFocusGained"](wrapper, ...)
		end
    end
    
    local function _New(parent)
		-- New Frame
		local txtBox = CreateFrame(_Base,nil,parent)
        txtBox.Height = 20
        txtBox.FontObject = "GameFontNormal"
        txtBox.MouseEnabled = true
        txtBox.AutoFocus = false
        
        local back = CreateFrame("Frame", "BackGround", txtBox)
        back.FrameLevel = txtBox.FrameLevel - 1
        back:SetPoint("TOPLEFT", txtBox, "TOPLEFT", -5, 3)
		back:SetPoint("BOTTOMRIGHT", txtBox, "BOTTOMRIGHT", 5, -3)        
		back:SetBackdrop(_FrameBackdrop)
		back:SetBackdropColor(0, 0, 0)
        back:SetBackdropColor(0, 0, 0, 1)
        
        txtBox:SetScript("OnEscapePressed", OnEscapePressed) 
        txtBox:SetScript("OnEditFocusLost", OnEditFocusLost) 
        txtBox:SetScript("OnEditFocusGained", OnEditFocusGained)
        
		return txtBox
	end	
	
	-- Register
    local _WidgetInfo = {
        ["WidgetName"] = _WidgetName,
        ["Base"] = _Base,
        ["FuncProxy"] = _FuncProxy,
        ["Property"] = _Property,
        ["ScriptType"] = _ScriptType,
        ["New"] = _New,
    }
    
    _Widget[_WidgetName] = _GUI.NewWidget(_WidgetInfo)
end
