﻿-- Author      : Kurapica
-- Create Date : 6/27/2008

--[[
The naming space of IGAS and version check.
In this system, each file register a key to mark it's version.It's used for version check.
--]]
do
	-- This file don't make version check,only load once.
	if IGAS and type(IGAS) == "table" then
		return
	end
	
	------------------------------------------------------
	------------------- Naming Space ---------------------
	------------------------------------------------------
	IGAS = {}
	IGAS_DB = {}

	------------------------------------------------------
	----------------- Register System --------------------
	------------------------------------------------------
	local _RegisterFile = {}
    
	local _metaF = {
		__index = {
			["Register"] = function(_key, _version)
                if _RegisterFile[_key] and _RegisterFile[_key] >= _version then
                    return false
                else
                    _RegisterFile[_key] = _version
                    return true
                end
            end,
            ["Print"] = function(...)
                local msg = ""
                if( DEFAULT_CHAT_FRAME ) then
                    for i = 1, select('#', ...) do
                        if msg ~= "" then msg = msg.."," end
                        msg = msg..tostring(select(i, ...))
                        end
                    DEFAULT_CHAT_FRAME:AddMessage(msg)
                end
            end,
		},
	
		__newindex = function(_table,_key,_value)
            if _key == "Register" then
			    error("This key is read-only", 2)
            end
            
            rawset(_table,_key,_value)
		end,
	}
    
	setmetatable(IGAS, _metaF)
end
