﻿-- Author   Kurapica
-- Date     2008/12/11
do
    -- Check Version
	local version = 1
	if not IGAS.Register("Cube.Main", version) then
		return
	end
	
    local L = IGAS.Localization.GetLocal("Cube")
    local CreateFrame = IGAS.GUI.CreateFrame
    
    local width
    
    CubeSave = {}
    
    BINDING_HEADER_CUBE = L["Cube"]
    BINDING_NAME_CUBE_CODE = L["Simple Dev Tool"]
    
    -- Main Form
    local cubeF = CreateFrame("Form", "Cube_Main")
    cubeF.Height = 400
    cubeF.Width = 500
    cubeF.Caption = "Cube - "..L["Simple Dev Tool"]
    cubeF.Visible = false
    cubeF:RegisterEvent("PLAYER_ENTERING_WORLD")
    cubeF:RegisterEvent("VARIABLES_LOADED")
    
    -- Timer
    local timer = CreateFrame("Timer", "InitTimer", cubeF)
    
    -- Code List
    local cboCode = CreateFrame("ComboBox", "CodeList", cubeF)
    cboCode.Editable = false
    cboCode:SetPoint("TOPLEFT", cubeF, "TOPLEFT", 4, -20)
    
    -- Code Name
    local codeName = CreateFrame("SingleTextBox", "Name", cubeF)
    codeName.Width = 100
    codeName:SetPoint("LEFT", cboCode, "RIGHT", 20, 0)
    
    -- Check AutoRun
    local chkAuto = CreateFrame("CheckBox", "AutoRun", cubeF)
    chkAuto.Text = L["AutoRun"]
    chkAuto:SetPoint("TOPRIGHT", cubeF, "TOPRIGHT", -4, -20)
    
    -- Code Form
    local code = CreateFrame("MultiLineTextBox", "Code", cubeF)
    code:SetPoint("TOPLEFT", cboCode, "BOTTOMLEFT", 0, -4)
    code:SetPoint("BOTTOMRIGHT", cubeF, "BOTTOMRIGHT", -4, 50)
    
    -- New Button
    local new = CreateFrame("Button", "New", cubeF)
	new.Height = 24
	new.Width = 60
	new.Style = "NORMAL"
    new.Text = L["New"]
    width = new:GetTextWidth()
	if ( width > 50 ) then
		new:SetWidth(width + 20)
	else
		new:SetWidth(60)
	end
    new:SetPoint("BOTTOMLEFT", cubeF, "BOTTOMLEFT", 4, 20)
    
    -- Save Button
    local save = CreateFrame("Button", "Save", cubeF)
	save.Height = 24
	save.Width = 60
	save.Style = "NORMAL"
    save.Text = L["Save"]
	width = save:GetTextWidth()
	if ( width > 50 ) then
		save:SetWidth(width + 20)
	else
		save:SetWidth(60)
	end
    save:SetPoint("LEFT", new, "RIGHT", 6, 0)
    
    -- Del Button
    local del = CreateFrame("Button", "Del", cubeF)
	del.Height = 24
	del.Width = 60
	del.Style = "NORMAL"
    del.Text = L["Del"]
    width = del:GetTextWidth()
	if ( width > 50 ) then
		del:SetWidth(width + 20)
	else
		del:SetWidth(60)
	end
    del:SetPoint("LEFT", save, "RIGHT", 6, 0)
    
    -- Debug Button
    local debug = CreateFrame("Button", "Debug", cubeF)
	debug.Height = 24
	debug.Width = 60
	debug.Style = "NORMAL"
    debug.Text = L["Debug"]
    width = debug:GetTextWidth()
	if ( width > 50 ) then
		debug:SetWidth(width + 20)
	else
		debug:SetWidth(60)
	end
    debug:SetPoint("LEFT", del, "RIGHT", 6, 0)
    
    -- BugList Button
    local bugList = CreateFrame("Button", "BugList", cubeF)
	bugList.Height = 24
	bugList.Width = 60
	bugList.Style = "NORMAL"
    bugList.Text = L["BugList"]
    width = bugList:GetTextWidth()
	if ( width > 50 ) then
		bugList:SetWidth(width + 20)
	else
		bugList:SetWidth(60)
	end
    bugList:SetPoint("LEFT", debug, "RIGHT", 6, 0)
    
    -- Run Button
    local run = CreateFrame("Button", "Run", cubeF)
	run.Height = 24
	run.Width = 60
	run.Style = "NORMAL"
    run.Text = L["Run"]
    width = run:GetTextWidth()
	if ( width > 50 ) then
		run:SetWidth(width + 20)
	else
		run:SetWidth(60)
	end
    run:SetPoint("BOTTOMRIGHT", cubeF, "BOTTOMRIGHT", -4, 20)
    
    -- Function
    local function Print(msg)
        if msg == nil then return end
        
        if( DEFAULT_CHAT_FRAME ) then
            DEFAULT_CHAT_FRAME:AddMessage(msg);
        end
    end
    
    -- Event
    function cubeF:VARIABLES_LOADED()
        local cboCode = self:GetChild("CodeList")
        
        CubeSave.AutoList = CubeSave.AutoList or {}
        CubeSave.CodeList = CubeSave.CodeList or {}        
        
        -- Init Code List
        if next(CubeSave.CodeList) then
            cboCode:SuspendLayout()
            for i in pairs(CubeSave.CodeList) do
                cboCode:AddItem(i, i)
            end
            cboCode:ResumeLayout()
        end
        
        -- Init BugList
        if cubeF.Parent:GetChild("Cube_BugList") then
            if not CubeSave.DisableBugList then
                cubeF.Parent:GetChild("Cube_BugList"):Fire("OnEnable")
            else
                cubeF.Parent:GetChild("Cube_BugList"):Fire("OnDisable")
            end
            if CubeSave.IconPosition then
                cubeF.Parent:GetChild("Cube_BugList"):GetChild("MapIcon").Position = CubeSave.IconPosition
            end
            cubeF.Parent:GetChild("Cube_BugList"):GetChild("MapIcon").Init = true
        end
    end
    
    function cubeF:PLAYER_ENTERING_WORLD()
        SLASH_Cube1 = "/cube"
        SlashCmdList["Cube"] = function() self.Visible = true end
        timer.Interval = 3
    end
    
    -- Script
    function cboCode:OnValueChanged(value)
        if CubeSave.CodeList[value] then
            codeName.Text = value
            code.Text = CubeSave.CodeList[value]
            chkAuto.Checked = (CubeSave.AutoList[value] and true) or false
        end
    end
    
    function chkAuto:OnValueChanged(value)
        if codeName.Text ~= "" and CubeSave.CodeList[codeName.Text] then
            CubeSave.AutoList[codeName.Text] = value
        end
    end
    
    function timer:OnTimer()
        local func, err
        self.Interval = 0
        
        -- Auto Init Code
        for code in pairs(CubeSave.AutoList) do
            if CubeSave.AutoList[code] and CubeSave.CodeList[code] then
                Print("Cube Loading ......"..code)
                func, err = loadstring(CubeSave.CodeList[code])
                if func then
                    func()
                else
                    Print(err)
                    if cubeF.Parent:GetChild("Cube_BugList") then
                        cubeF.Parent:GetChild("Cube_BugList").grabError(err)
                    end
                end
            end
        end
        
        self:Dispose()
    end
    
    function new:OnClick()
        cubeF.Message = ""
        codeName.Text = ""
        code.Text = ""
        cboCode.Text = ""
        chkAuto.Checked = false
    end
    
    function save:OnClick()
        cubeF.Message = ""
        
        if codeName.Text == "" then
            cubeF.Message = L["Must set code name."]
            return
        end
        
        if code.Text == "" then
            cubeF.Message = L["Must set code."]
            return
        end
        
        CubeSave.AutoList[codeName.Text] = chkAuto.Checked
        CubeSave.CodeList[codeName.Text] = code.Text
        cboCode:AddItem(codeName.Text, codeName.Text)
        cboCode.Value = codeName.Text
    end
    
    function del:OnClick()
        cubeF.Message = ""
        
        if codeName.Text ~= "" then
            CubeSave.AutoList[codeName.Text] = nil
            CubeSave.CodeList[codeName.Text] = nil
            cboCode:RemoveItem(codeName.Text)
            cboCode.Text = ""
        end
        codeName.Text = ""
        code.Text = ""
        chkAuto.Checked = false
    end
    
    function run:OnClick()
        cubeF.Message = ""
        
        local func, err
        
        if code.Text ~= "" then
            func, err = loadstring(code.Text)()
        
            if func then
                func()
            else                
                Print(err)
                if cubeF.Parent:GetChild("Cube_BugList") then
                    cubeF.Parent:GetChild("Cube_BugList").grabError(err)
                end
            end
        end
    end
    
    function debug:OnClick()
        if cubeF.Parent:GetChild("Cube_Debug") then
            cubeF.Parent:GetChild("Cube_Debug").Visible = true
        end
    end
    
    function bugList:OnClick()
        if cubeF.Parent:GetChild("Cube_BugList") then
            cubeF.Parent:GetChild("Cube_BugList").Visible = true
        end
    end
end